import GlMap from "./components/map/GlMap.vue";

import NavigationControl from "./components/UI/controls/NavigationControl";
import GeolocateControl from "./components/UI/controls/GeolocateControl";
import FullscreenControl from "./components/UI/controls/FullscreenControl";
import AttributionControl from "./components/UI/controls/AttributionControl";
import ScaleControl from "./components/UI/controls/ScaleControl";

import BaseDraw from "./components/UI/draw/BaseDraw";
import BaseDrawItem from "./components/UI/draw/BaseDrawItem";

import Marker from "./components/UI/Marker.vue";
import Popup from "./components/UI/Popup.vue";

import GeojsonLayer from "./components/layer/GeojsonLayer";
import ImageLayer from "./components/layer/ImageLayer";
import CanvasLayer from "./components/layer/CanvasLayer";
import VideoLayer from "./components/layer/VideoLayer";
import VectorLayer from "./components/layer/VectorLayer";
import RasterLayer from "./components/layer/RasterLayer";

import withEventsMixin from "./lib/withEvents";
import withSelfEventsMixin from "./components/UI/withSelfEvents";
import controlMixin from "./components/UI/controls/controlMixin";
import layerMixin from "./components/layer/layerMixin";

export const withEvents = withEventsMixin;
export const withSelfEvents = withSelfEventsMixin;
export const asControl = controlMixin;
export const asLayer = layerMixin;

export const $helpers = {
  withEvents: withEventsMixin,
  withSelfEvents: withSelfEventsMixin,
  asControl: controlMixin,
  asLayer: layerMixin
};

export const MapboxMap = GlMap;

export const MapboxNavigationControl = NavigationControl;
export const MapboxGeolocateControl = GeolocateControl;
export const MapboxFullscreenControl = FullscreenControl;
export const MapboxAttributionControl = AttributionControl;
export const MapboxScaleControl = ScaleControl;

export const MapboxBaseDraw = BaseDraw;
export const MapboxBaseDrawItem = BaseDrawItem;

export const MapboxGeojsonLayer = GeojsonLayer;
export const MapboxImageLayer = ImageLayer;
export const MapboxCanvasLayer = CanvasLayer;
export const MapboxVideoLayer = VideoLayer;
export const MapboxVectorLayer = VectorLayer;
export const MapboxRasterLayer = RasterLayer;

export const MapboxMarker = Marker;
export const MapboxPopup = Popup;

export default GlMap;
